#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/socket.h>
#include <netpacket/packet.h>
#include <net/ethernet.h> 
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netpacket/packet.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/fcntl.h>
#include <netinet/ether.h>
#include <time.h>

#include "endianness.h"

#define ETH_P_DCBX	0x88cc

int show_value = 0;
int show_lldp_shell = 0;
int show_dcbx_shell = 1;
int stdin_mode = 0;

int tabs = 0;
int ident()
{
	int i;
	for(i = 0; i < tabs; i++) printf("\t");
	return i;
}

void print_clock()
{
	time_t now_t;
	time(&now_t);
	struct tm *now_s;
	now_s = localtime(&now_t);
	
	char now_buf[80];
	strftime(now_buf, sizeof(now_buf), "%H:%M:%S", now_s);
	printf("%s",now_buf);
}

void print_hex(unsigned char *buf, int length)
{
	int i;
	for (i = 0; i < length; i++) {
		if ((i%16 == 0) && (i != 0)) printf("\n");
		if (i%16 == 0) ident();
		printf("%.2x", buf[i]&0xff);
                if (i%2) printf(" ");
	}	

	printf("\n");
}

int get_type(unsigned char *buf)
{
	return buf[0]>>1;
}

int get_length(unsigned char *buf)
{
	return buf[1]+((buf[0]&0x1)<<8);
}

int for_each_tlv(unsigned char *buf, int size, void(*parse_tlv)
		 (int type, int length, unsigned char* value))
{
	int i;
	int length;
	int type;

	for (i = 0; i < size; i += length + 2) {
		type = get_type(buf + i);
		length = get_length (buf + i);
		parse_tlv(type, length, buf + i + 2);
	}
	return i;
}

char* type2name(int type) {
	switch (type) {
	case 0:
		return "End_Of_LLDPDU";
	case 1:
		return "Chassis_ID";
	case 2:
		return "Port_ID";
	case 3:
		return "Time_To_Live";
	case 4:
		return "Port_Description";
	case 5:
		return "System_Name";
	case 6:
		return "System_Description";
	case 7:
		return "System_Capabilities";
	case 8:
		return "Management_Address";
	case 127:
		return "Organizationally Specific";
	}
	return "unknown_type";
}

char* subtype2name(int type) {
	switch (type) {
	case 1:
		return "Protocol_Control";
	case 2:
		return "Prioroty_Groups";
	case 3:
		return "Priority_Flow_Control";
	case 4:
		return "BCN";
	case 5:
		return "Application";
	case 6:
		return "Logical_Link_Down";
	}
	return "unknown_type";
}

struct protocol_control {
	unsigned char oper_version;
	unsigned char max_version;
	unsigned int seqno;
	unsigned int ackno;
};

void parse_protocol_control(unsigned char *buf, struct protocol_control *pc)
{
	pc->oper_version = buf[0];
	pc->max_version = buf[1];
 	pc->seqno = be32_to_cpu (buf + 2); 
 	pc->ackno = be32_to_cpu (buf + 2 + 4); 
	
	if (show_value) {
		ident(), printf("oper_version: %d\n", pc->oper_version);
		ident(), printf("max_version: %d\n", pc->max_version);
	}
	ident(), printf("seqno: %u\n", pc->seqno);
	ident(), printf("ackno: %u\n", pc->ackno);
}

struct feature_header {
	unsigned char oper_version; 
	unsigned char max_version;
	int enable;
	int willing;
	int error;
	int sub_type;
};

void parse_feature_header(unsigned char *buf, struct feature_header *fh)
{
	fh->oper_version = buf[0];
	fh->max_version = buf[1];	
	fh->enable = (buf[2] & 0x80)?1:0;
	fh->willing = (buf[2] & 0x40)?1:0;
	fh->error = (buf[2] & 0x20)?1:0;
	fh->sub_type = buf[3];
	
	if (show_value) {
		ident(), printf("oper_version: %d\n", fh->oper_version);
		ident(), printf("max_version: %d\n", fh->max_version);
	}
	ident(), printf("enable: %d ", fh->enable);
	printf("willing: %d ", fh->willing);
	printf("error: %d\n", fh->error);
	ident(), printf("sub_type: %d\n", fh->sub_type);
}

void parse_sub_tlv(int type, int length, unsigned char *buf)
{
	if(show_dcbx_shell){
		ident(), printf("type: %d %s\n", type, subtype2name(type));
		ident(), printf("length: %d\n",length);
		
		if(show_value){
			ident(), printf("value: \n");
			print_hex(buf, length);
		}
	
		tabs++;
	}

	if (type == 1) {
		struct protocol_control pc;
		parse_protocol_control(buf, &pc);
	} else {
		struct feature_header fh;
		parse_feature_header(buf, &fh);
		
		if((type == 5) && (fh.sub_type == 0))
			ident(), printf("it's FCoE\n");

		if((type == 6) && (fh.sub_type == 0))
			ident(), printf("it's FCoE\n");
		if((type == 6) && (fh.sub_type == 1))
			ident(), printf("it's LAN\n");


		int show_cfg = 1;
		switch (type) {
		case 5:
			ident(), printf("user_priority_map: %d\n",buf[4]);
			show_cfg = 0;
			break;
		case 6:
			ident(), printf("local_link_status: %d\n",buf[4]>>7);
			show_cfg = 0;
			break;
		}
		
		if(show_cfg || show_value){
			ident(), printf("cfg: ");
			int temp_tabs = tabs;
			tabs = 0;
			print_hex(buf + 4, length - 4);
			tabs =temp_tabs;
		}
	}

	if(show_dcbx_shell){
		tabs--;
	}
}

int is_intel_oui(unsigned char *buf)
{
	return ((buf[0]==0x00)&&(buf[1]==0x1b)
		&&(buf[2]==0x21));
}

int is_dcbx(unsigned char *buf)
{
	return ((buf[0]==0x00)&&(buf[1]==0x1b)
		&&(buf[2]==0x21)&&(buf[3]==1));
}

void parse_org_spec(unsigned char *buf, int length)
{
	if(show_lldp_shell){
		ident(), printf("OUI: %.2x:%.2x:%.2x "
				, buf[0], buf[1], buf[2]);
		if (is_intel_oui(buf)) printf("intel");
		printf("\n");
	}

	char subtype = buf[3];

	if(show_lldp_shell){
		ident(), printf("subtype: %d ", subtype);
		if (is_dcbx(buf)) printf("dcbx");
		printf("\n");

		if(show_value){
			ident(), printf("information: \n");
			print_hex(buf, length);
		}

		tabs++;
	}

	if ((is_dcbx(buf)) && show_dcbx_shell) for_each_tlv(buf + 4, length - 4, parse_sub_tlv);

	if(show_lldp_shell){
		tabs--;
	}
}

void parse_lldp_tlv(int type, int length, unsigned char *buf)
{
	if(show_lldp_shell){
		ident(), printf("type: %d %s\n", type, type2name(type));
		ident(), printf("length: %d\n",length);
		
		if(show_value){
			ident(), printf("value: \n");
			print_hex(buf, length);
		}
	
		tabs++;
	}

	if (type == 127) parse_org_spec(buf, length);

	if(show_lldp_shell){
		tabs--;
	}
}
		
void print_mac(unsigned char *buf)
{
	int i;
	for(i = 0; i < 6; i++) {
		printf("%.2x", buf[i]&0xff);
                if (i!=5) printf(":");
	}
}		

int parse_packet(unsigned char* buf,int size)
{
	ident();
	print_clock();
	printf(" ");
	print_mac(buf+6);
	printf(" > ");
	print_mac(buf);
	printf ("\n");

	if(show_lldp_shell){
		ident(), printf ("size: %d\n",size);
		if(show_value){
			print_hex(buf + 14, size - 14);
		}
	}
	
	for_each_tlv(buf + 14, size - 14, parse_lldp_tlv);
	printf("\n");
	return 0;
}

int server()
{
	unsigned char buf[10000];
	int soc  = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_DCBX));

	while (1) {
		int size = recvfrom(soc, (void *)buf, sizeof(buf), 0, 0, 0); 
		if (size < 0) {
			ident(), printf("rceive from socket error: %s\n", 
			       strerror(errno));
		} else if (size > 0) {
			parse_packet(buf, size);
		}

		sleep(1);
	}
	return 0;
}

void parse_args(int argv, char **argc)
{
	int i;
	if (argv > 1)
		for (i = 0; i < strlen(argc[1]); i++) {
			switch (argc[1][i]) {
			case 'v':
				show_value = !show_value;
				break;
			case 'l':
				show_lldp_shell = !show_lldp_shell;
				break;
			case 'd':
				show_dcbx_shell = !show_dcbx_shell;
				break;
			case 's':
				stdin_mode = !stdin_mode;
				break;
			default:
				printf("unknown flag: %c\n", argc[1][i]);
			}
		}
	printf ("show_value: %d, show_lldp_shell: %d, show_dcbx_shell: %d, stdin_mode: %d\n",
		show_value, show_lldp_shell, show_dcbx_shell, stdin_mode);
}

//discard mode: buf == 0.
void read_hex(unsigned char *buf, int length)
{	
	int i;
	unsigned char c;
	for (i = 0; i < length; i++) {
		scanf("%c",&c);
		if (buf) buf[i] = c;
	}
}

void pass_tcpdump_file_header()
{
	read_hex(0, 24);
}

int get_tcpdump_packet_actual_size()
{
	unsigned char c;
	scanf("%c",&c);
	return c&0xff;
}

void read_from_stdin()
{
	int size;
	unsigned char buf[1000];

	pass_tcpdump_file_header();
	do {
		read_hex(0, 8);
		size = get_tcpdump_packet_actual_size();
		read_hex(0, 7);
		read_hex(buf, size);
		parse_packet(buf, size);
	} while (size);
}

int main(int argv, char **argc)
{
	parse_args(argv, argc);
	if (!stdin_mode) {
		server();
	} else {
		read_from_stdin();
	}
	return 0;
}

