struct lldp_header {
	unsigned char chassis_id[7];
	unsigned char port_id[7];
	short ttl;
};

struct protocol_control {
	unsigned char oper_version;
	unsigned char max_version;
	int seqno;
	int ackno;
};

struct feature {
	int type;
	unsigned char oper_version;
	unsigned char max_version;
	int enable;
	int willing;
	int error;
	int sub_type;

	unsigned char cfg[10];
	int cfg_size;
};

struct packet {
	struct lldp_header lh;
	struct protocol_control pc;
	struct feature fe[10];
	int fe_size;
};

struct interface_context {
	char *name;
	int if_index;
	int socket_handle;
	struct sockaddr_ll sll;
	unsigned char mac[6];

	int link_state;
	int announced_create;
	int dirty;
	int tell_kernel_link_changed;

	int seqno;
	int ackno;
	unsigned char fcoe_cfg;
	int priority_flow_control;

	struct packet pkt;
	time_t expires;
	
	int saw_an_fcoe_application_tlv;
	int prio;
};

