#include "sysfs.h"

char *path_to_sysfs;

extern int monitor_writing_to_sysfs;

int init_sysfs_interface(char *path)
{
	path_to_sysfs = path;
}

int open_file(char *file_name, int flags)
{
	char full_file_name[300];
	int fd;

	sprintf(full_file_name,"%s/%s", path_to_sysfs, file_name);
	fd = open(full_file_name, flags);
	if (fd < 0) {
		printf("open_file %s: error: %s\n", full_file_name, strerror(errno));
	}
	return fd;
}

int close_file(int fd)
{
	char full_file_name[300];
	int ret;

	ret = close(fd);
	if (ret < 0) {
		printf("close_file: error: %s\n", strerror(errno));
	}
	return ret;
}

int write_buffer_to_sysfs(unsigned char* buf, int length, char* file)
{
	int fd, i, ret;

	fd = open_file(file, O_WRONLY | O_TRUNC);
	if (fd < 0) return -1;

	if (monitor_writing_to_sysfs) {
		printf("[write to sysfs] %s: ", file);
		for (i = 0; i < length; i++)
			printf("%c", buf[i]);
		printf("\n");
	}
	
	ret = write(fd, (const void *)buf, (size_t) length); 

	close_file(fd);
	return ret;
}

int read_buffer_from_file(unsigned char* buf, int length, char* file)
{
	int fd, ret;

	fd = open_file(file, O_RDONLY);
	if (fd < 0) return -1;

	ret = read(fd, (void *)buf, (size_t) length); 

	close_file(fd);
	return ret;
}

int check_file(char *file)
{
	int ret;

	ret = open_file(file, O_WRONLY);
	if (ret >= 0) 
		ret = close(ret);
	return ret;
}
