#ifndef BACKPORT_LINUX_NET_H
#define BACKPORT_LINUX_NET_H

#include_next <linux/net.h>
#include <linux/random.h>

static inline
int kernel_getsockname(struct socket *sock, struct sockaddr *addr,
			 int *addrlen)
{
	return sock->ops->getname(sock, addr, addrlen, 0);
}

static inline
int kernel_getpeername(struct socket *sock, struct sockaddr *addr,
			 int *addrlen)
{
	return sock->ops->getname(sock, addr, addrlen, 1);
}

enum sock_shutdown_cmd {
       SHUT_RD         = 0,
       SHUT_WR         = 1,
       SHUT_RDWR       = 2,
};

static inline
int kernel_sock_shutdown(struct socket *sock, enum sock_shutdown_cmd how)
{
	return sock->ops->shutdown(sock, how);
}

static inline
int kernel_bind(struct socket *sock, struct sockaddr *addr, int addrlen)
{
	return sock->ops->bind(sock, addr, addrlen);
}

static inline
int kernel_listen(struct socket *sock, int backlog)
{
	return sock->ops->listen(sock, backlog);
}

static inline
int kernel_connect(struct socket *sock, struct sockaddr *addr, int addrlen, 
		int flags)
{
	return sock->ops->connect(sock, addr, addrlen, 0);
}

static inline
int kernel_sendpage(struct socket *sock, struct page *page, int offset,
		size_t size, int flags)
{
	return sock->ops->sendpage(sock, page, offset, size, flags);
}
#endif
