#!/bin/bash
# Usage: mlxfc_checkout.sh <branch>

# Execute command w/ echo and exit if it fail
ex()
{
        echo "$@"
        eval "$@"
        if [ $? -ne 0 ]; then
                printf "\nFailed executing $@\n"
                exit 1
        fi
}


ex git checkout $1 `git-ls-tree -r --name-only $1 \
        include/scsi/fc \
	include/scsi/fc_encode.h \
	include/scsi/fc_frame.h \
	include/scsi/fc_transport_fcoe.h \
	include/scsi/libfc.h \
	include/scsi/libfcoe.h \
        scripts/mlxfc.spec \
        scripts/mlxfc \
        scripts/mlxfc.conf \
        scripts/mlxfc_patch.sh \
        scripts/open-fcoe-initiator.sh \
        scripts/makefile.mlnx_ofc \
        scripts/Makefile.mlnx_ofc \
        FCOE_README.txt \
        kernel_patches \
        drivers/scsi/fcoe \
        drivers/scsi/libfc \
        drivers/scsi/mlx4_fc \
        `
ex git update-ref HEAD $1

